<template lang="pug">
  .layout(:id="id", :style="style")
    the-navbar
    main
      nuxt
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'nuxt-property-decorator';

const MIN_SIZE = 1;
const MAX_SIZE = 2;

const MIN_ITEMS = 0.0001;
const MAX_ITEMS = 0.00025;

const DEFAULT_WIDTH = 1360;
const DEFAULT_HEIGHT = 768;

@Component({
  components: {
    TheNavbar: () => import(/* webpackChunkName: "the-navbar" */ '../components/ui/TheNavbar.vue'),
  },
})
class LayoutDefault extends Vue {
  @Prop()
  private id!: string;

  width = DEFAULT_WIDTH;
  height = DEFAULT_HEIGHT;

  get size() {
    return this.width * this.height;
  }

  get query() {
    return [
    `width=${this.width}`,
    `height=${this.height}`,

    `minSize=${MIN_SIZE}`,
    `maxSize=${MAX_SIZE}`,

    `minItems=${Math.round(this.size * MIN_ITEMS)}`,
    `maxItems=${Math.round(this.size * MAX_ITEMS)}`,

    'colors=white',
    ];
  }

  get style() {
    return {
      background: `url(/api/background?${this.query.join('&')})`,
    };
  }

  onResize(event: Event) {
    this.width = (event.target as Window).innerWidth;
    this.height = (event.target as Window).innerHeight;
  }

  mounted() {
    if (process.client) {
      window.addEventListener('resize', this.onResize);
    }
  }

  beforeDestroy() {
    if (process.client) {
      window.removeEventListener('resize', this.onResize);
    }
  }
}

export default LayoutDefault;
</script>

<style lang="sass" scoped>
.layout
  position: relative

  .the-navbar
    width: 100%
    position: fixed

  .columns
    height: 100%

  .column
    height: 100%

  main
    width: 100%
    height: 100vh
    padding-top: var(--navbar-height)
    position: relative

  .page
    display: flex
    align-items: center
    justify-content: center
    flex-direction: column

    height: 100%
    width: 100%

    overflow: auto
</style>

<style lang="sass">
html,
body
  background: var(--body-background)
  overflow-y: var(--body-overflow-y)

  margin: var(--body-margin)
</style>

<style>
:root {
  --midnight-express: #010018;

  --body-background: var(--midnight-express);
  --body-overflow-y: auto!important;
  --body-margin: 0;
  --body-min-width: 100vw;
}
</style>
